---
title: Sanitizer()
slug: Web/API/Sanitizer/Sanitizer
tags:
  - Constructor
  - HTML Sanitizer API
  - sanitize
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("HTML Sanitizer API")}}</div>

<p class="summary">The <strong><code>Sanitizer()</code></strong> constructor creates a new {{domxref("sanitizer")}} object which allows developers to take untrusted strings of HTML, and sanitize them for safe insertion into a document’s DOM.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>sanitizer</var> = new Sanitizer();</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>config</code> {{optional_inline}}</dt>
 <dd>An object in the format of SanitizerConfig. Options are as follows:
 <ul>
  <li><code>allowElements</code>: An {{jsxref('Array')}} of {{jsxref('String','strings')}} representing elements the sanitizer should retain in the input.</li>
  <li><code>blockElements</code>: An {{jsxref('Array')}} of {{jsxref('String','strings')}} representing elements the sanitizer should remove in the input, but retain any of their children elements.</li>
  <li><code>dropElements</code>: An {{jsxref('Array')}} of {{jsxref('String','strings')}} representing elements the sanitizer should remove in the input along with their children.</li>
  <li><code>allowAttributes</code>: An {{jsxref('Array')}} of {{jsxref('String','strings')}} representing attributes the sanitizer should retain in the input.</li>
  <li><code>dropAttributes</code>: An {{jsxref('Array')}} of {{jsxref('String','strings')}} representing attributes the sanitizer should remove in the input.</li>
 </ul>
 </dd>
</dl>

<div class="note">
<p>At the time of writing the default elements within each configuration property above are still under consideration. Due to this the above config parameter has not been implemented.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>This example shows the result of sanitizing a string with disallowed <code>script</code> elements.</p>

<pre class="brush: js notranslate">new Sanitizer().sanitizeToString("abc &lt;script&gt;alert(1)&lt;/script&gt; def");
// Result: script will be removed: "abc alert(1) def"
</pre>

<p>This example shows how the different configuration options would return the same string.</p>

<pre class="brush: js notranslate">const sample = "Some text &lt;b&gt;&lt;i&gt;with&lt;/i&gt;&lt;/b&gt; &lt;blink&gt;tags&lt;/blink&gt;.";

const allow = new Sanitizer({allowElements: [ "b" ]).sanitizeToString(sample);
console.log(allow)
// Logs: "Some text &lt;b&gt;with&lt;/b&gt; text tags."

const block = new Sanitizer({blockElements: [ "b" ]).sanitizeToString(sample);
console.log(block);
// Logs: "Some text &lt;i&gt;with&lt;/i&gt; &lt;blink&gt;tags&lt;/blink&gt;."

const drop = new Sanitizer({dropElements: [ "b" ]).sanitizeToString(sample);
// Logs: "Some text tags."
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML Sanitizer API','#sanitizer-api','sanitizer')}}</td>
   <td>{{Spec2('HTML Sanitizer API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Sanitizer.Sanitizer")}}</p>
